/*
 * $Id: CaptureDialog.java,v 1.1.1.1 2002/12/09 17:58:12 sugiyama Exp $
 * Copyright (c) 2002 Hidenori Sugiyama
 */

package to.hslab.jws.capture;

import java.awt.*;
import java.awt.image.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.*;

public class CaptureDialog extends JDialog implements WindowListener, ActionListener {
	private JButton captureButton;
	private JFormattedTextField delayTimeField;
	private JFrame previewFrame;
	private PreviewPanel previewPanel;

	public CaptureDialog() {
		super();
		setTitle("Capture");

		captureButton = new JButton("capture!");
		delayTimeField = new JFormattedTextField(new Integer(0));
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(new JLabel("delay time"), "West");
		getContentPane().add(delayTimeField, "Center");
		getContentPane().add(captureButton, "South");

		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		setSize(200, 80);

		addWindowListener(this);
		captureButton.addActionListener(this);

		preparePreview();
	}

	public void actionPerformed(ActionEvent event) {
		if (event.getSource() == captureButton) {
			int delayTime = Integer.parseInt(delayTimeField.getText());

			captureButton.setEnabled(false);
			delayTimeField.setEnabled(false);
			previewFrame.setVisible(false);

			java.util.Timer timer = new java.util.Timer();
			timer.schedule(new TimerTask() {
				public void run() {
					setVisible(false);
					doCapture();
					setVisible(true);

					captureButton.setEnabled(true);
					delayTimeField.setEnabled(true);
				}
			}, delayTime * 1000);
		}
	}

	public void windowActivated(WindowEvent event) {
	}

	public void windowClosed(WindowEvent e) {
		System.exit(0);
	}

	public void windowClosing(WindowEvent event) {
	}

	public void windowDeactivated(WindowEvent e){
	}

	public void windowDeiconified(WindowEvent e) {
	}

	public void windowIconified(WindowEvent e) {
	}

	public void windowOpened(WindowEvent e) {
	}

	private void doCapture() {
		try {
		    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
			Robot robot = new Robot();
			BufferedImage image = robot.createScreenCapture(new Rectangle(screenSize));

			previewPanel.setImage(image);
			previewFrame.setVisible(true);
		} catch(AWTException e) {
			Toolkit.getDefaultToolkit().beep();
			e.printStackTrace();
		}
	}

	private void preparePreview() {
		previewFrame = new JFrame("Capture: Preview");
		previewFrame.setSize(320, 240);
		previewFrame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);

		previewPanel = new PreviewPanel();
		previewPanel.setSize(320, 240);
		previewFrame.getContentPane().add(previewPanel);
	}
}
